import 'dart:io';

import 'package:translator/translator.dart';

String projectAbsolutePath ="";
String defaultLocal ='';
_write(Map jsonData,String local) async {
  String dataToWrite = '{\n';
  final File file = File('$projectAbsolutePath/assets/app_auto_localize/$local.json');
  await file.create();
  for (String key in jsonData.keys){
    if(validateEntry(key))
      dataToWrite=dataToWrite+key+':'+jsonData[key]+','+'\n';
  }
  dataToWrite=dataToWrite.substring(0,dataToWrite.length-2);
  dataToWrite=dataToWrite+'\n}';
  file.writeAsString(dataToWrite);
}

bool validateEntry(key) => !key.contains("\$")&&!key.contains(":")&&!key.contains("#")&&!key.contains("\\")&&!key.contains("\/")&&key.trim().isNotEmpty&&!key.contains("[")&&!key.contains("^")&&!key.contains("]")&&!key.contains("*")&&key.trim()!=""&&!key.contains("|");


List<String?> jsonData = [];
readContentItem(i,String local) async {
  if(_folders[i].path.contains('.dart')){
    final file =File(_folders[i].path);
    // Read the file
    final newFileContent = await file.readAsString();
    List<String?> newArray = extractHashtags(newFileContent);
    jsonData =  jsonData+newArray;
    if(i==_folders.length-1){
      print("strings :");
      print(jsonData);
      Map jsonResult = {};
      for(int i=0;i<jsonData.length;i++){
        jsonResult[jsonData[i]] = "\"\"";
      }
      _write(jsonResult,local);
      // transl(jsonData,local);
    }
  }

}
Future<String> transl(List list,String local) async {
  final textToTranslate = jsonData.join('大');
  final translator = GoogleTranslator();
  var result =  await translator.translate(textToTranslate, from: defaultLocal, to: local);
  List translatedResult = result.text.split('大');
  Map jsonResult = {};
  for(int i=0;i<list.length;i++){
    jsonResult[list[i]] = (translatedResult[i]==''||translatedResult[i]==null)?'-':translatedResult[i];
  }
  _write(jsonResult,local);

  return result.text;
}

readContent(String local) async {
  getDir();
  for(int i=0;i<_folders.length;i++){
    readContentItem(i,local);
  }
}

List<FileSystemEntity> _folders=[];
getDir()  {
  final dir = '$projectAbsolutePath/lib';
  String pdfDirectory = '$dir/';
  final myDir = new Directory(pdfDirectory);
  _folders = myDir.listSync(recursive: true, followLinks: false);
  return _folders;
}

List<String?> extractHashtags(String data) {
  var r1 = r'"([^]*?)"';
  var r2 = r'"([^]*?)"';

  final res = new RegExp('(' + r1 + ")|(" + r2 + ')');
  List<String?> result = res.allMatches(data.trim()).map((data) => data.group(0)).toList();
  return result ;
}
initAutoTranslate({ required String projectPathApsolute,
  required List<String> locals,
  required String baseLocal})    async {
  projectAbsolutePath = projectPathApsolute;
  defaultLocal = baseLocal;
  await Future.wait(locals.map((e) async {
    await  readContent(e);
  }));
}
